using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration.Install;
using System.Collections;
using System.ComponentModel;
using Microsoft.Win32;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;

namespace PhoenixUninstaller.Class
{
    /// <summary>
    /// Description rsume de DemoInstaller.
    /// </summary>
    [RunInstaller(true)]
    public class InstallClass : Installer
    {
        /// <summary>
        /// Fait la dsinstallation
        /// </summary>
        /// <param name="savedState"></param>
        public override void Uninstall(IDictionary savedState)
        {
            base.Uninstall(savedState);

            FinishRemove();
        }

        #region Mthodes
        /// <summary>
        /// Termine l'effacement de la base de registre
        /// </summary>
        private void FinishRemove()
        {
            #region Effacement des derniers fichiers
            RegistryKey CUKey = Registry.CurrentUser;
            RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Phoenix\", false);

            if (key == null)
            {
                MessageBox.Show("Les informations d'installation de Phoenix sont corrompues",
                    "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
            {
                try
                {
                    string Path = (string)key.GetValue("Path");
                    Directory.Delete(Path, true);
                    key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                    key.DeleteSubKey("Phoenix");

                }
                catch (DirectoryNotFoundException)
                { MessageBox.Show("Phoenix est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                catch (UnauthorizedAccessException) { }

            }
            #endregion

            #region Effacement de la base de registre
            RegistryKey _CUKey = Registry.CurrentUser;
            RegistryKey _key = _CUKey.OpenSubKey(@"Software\\", true);

            if (_key != null)
            {
                try { _key.DeleteSubKeyTree("Phoenix"); }
                catch (ArgumentException) { /*La clef n'existe pas ;)*/}
                catch (Exception ex)
                {
                    MessageBox.Show("Une erreur est intervenue:\r\n" + ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }
            #endregion
        }
        #endregion
    }
}
